unit coaGenl;
// Types, constants, and functions used by multiple units
interface
var
  NTVersion : Integer;
const
  // NT version constants
  NotNT = 0;
  NT351 = 1;
  NT4   = 2;
  // source type constants
  stNONE = 0;
  stINI  = 1;
  stGRP  = 2;
  stLNK  = 3;
  stREG  = 4;
  // search type constants
  srchNone      = 0;
  srchWinDir    = 1;
  srchWinDirAnd = 2;
  srchAll       = 3;
  srchSpecial   = 4;
  // sub item type constants
  sitNone       = 0;
  sitSection    = 1; // INI
  sitCommand    = 2; // GRP and LNK
  sitIconLoc    = 3; // GRP and LNK
  sitWorkDir    = 4; // GRP and LNK
  sitArguments  = 5; // LNK
  sitKey        = 6; // INI and REG
  sitValue      = 7; // REG
  sitData       = 8; // REG
  //1.01
  sitDatEx      = 9; // REG
  sitLast       = sitDatEx;
  //1.01

SearchExts : ARRAY[stNone..stReg] OF String =
  ('err', 'INI', 'GRP', 'LNK', 'REG');
SITNames : ARRAY[sitNone..sitLast] OF String =
  ('err', 'sec', 'cmd', 'ico', 'dir', 'arg', 'key', 'val', 'dat',
   {1.01}'dat');

function NamBak(const S : String) : String;
function NamTmp(const S : String) : String;
PROCEDURE StrChange(VAR S : String; CONST Find, Rep : String);
FUNCTION StrChangeF(CONST S, Find, Rep : String) : String;


implementation
USES Windows, SysUtils;

function NamBak(const S : String) : String;
begin
  Result := ChangeFileExt(S, '.BAK');
end;

function NamTmp(const S : String) : String;
begin
  Result := ChangeFileExt(S, '.$$$');
end;

PROCEDURE StrChange(VAR S : String; CONST Find, Rep : String);
{Non-recursive procedure to change string Find to string Rep
 wherever found in string S}
VAR Loc, First : Word;
BEGIN
  IF Length(Find) = 0 THEN Exit;
  IF Length(S) < Length(Find) THEN Exit;
  First := 1;
  WHILE True DO
    BEGIN
      Loc := Pos(Uppercase(Find),
                 Uppercase(Copy(S, First, Length(S)-First+1)));
      IF Loc = 0 THEN Exit;
      Loc := First + Loc - 1;
      System.Delete(S, Loc, length(Find));
      System.Insert(Rep, S, Loc);
      First := Loc + length(Rep);
    END;
END;

FUNCTION StrChangeF(CONST S, Find, Rep : String) : String;
begin
  Result := S;
  StrChange(Result, Find, Rep);
end;

var OVI : TOsVersionInfo;

initialization
  OVI.dwOSVersionInfoSize := SizeOf(OVI);
  GetVersionEx(OVI);
  IF OVI.dwPlatformID = VER_PLATFORM_WIN32_NT THEN
    begin
      IF OVI.dwMajorVersion < 4 THEN NTVersion := NT351
      ELSE NTVersion := NT4;
    end
  ELSE NTVersion := NotNT;
end.
