unit mainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, Menus, StdCtrls, ComCtrls, DdeMan,
  CoaThds;

const
  COA32Key = 'Software\PC Magazine\COA32\1.0';
  nbPgFromAndTo     = 0;
  nbPgIniFiles      = 1;
  nbPgGroups        = 2;
  nbPgShortcuts     = 3;
  nbPgRegistry      = 4;
  nbPgIgnoreKeys    = 5;
  nbPgConfirm       = 6;
  nbPgSearch        = 7;
  nbPgFinalPage     = 8;
  nbPgReplacing     = 9;
  nbPgFinalFinal    = 10;
  nbFirstPage       = nbPgFromAndTo;
  nbLastPage        = nbPgFinalFinal;
  nbSbSearching     = 0;
  nbSbSearchResults = 1;
  nbSbSearched      = 2;
const
  // OK input status
  riOK          = 0;
  riOKNoNew     = 1;
  // "note" input status
  riOldShort    = 2;
  riNewShort    = 3;
  riNeither     = 4;
  riBothFile    = 5;
  riBothDir     = 6;
  // "possible error" input status
  riNoAddress   = 7;
  riFileDir     = 8;
  riDirFile     = 9;
  riNoBothExt   = 10;
  riNoBothDrv   = 11;
  riNoBothSlash = 12;
  riNoBothDot   = 13;

type
  TForm1 = class(TForm)
    NotebookMain: TNotebook;
    cbSkipGroups: TCheckBox;
    cbSkipShortcuts: TCheckBox;
    Panel1: TPanel;
    Image1: TImage;
    pmWhatsThis: TPopupMenu;
    WhatsThis1: TMenuItem;
    EditOldAddress: TEdit;
    EditNewAddress: TEdit;
    rgIniFiles: TRadioGroup;
    OpenDialog1: TOpenDialog;
    cbSkipIniFiles: TCheckBox;
    rgShortcuts: TRadioGroup;
    lbIgnoreKey: TListBox;
    lblFrom: TLabel;
    lblTo: TLabel;
    lblIni: TLabel;
    lblGroup: TLabel;
    lblShortcut: TLabel;
    lblReplace: TLabel;
    cbSkipIgnoreKeys: TCheckBox;
    lvFound: TListView;
    rgGroups: TRadioGroup;
    SaveDialog1: TSaveDialog;
    cbSkipRegistry: TCheckBox;
    rgRegistry: TRadioGroup;
    lblRegistry: TLabel;
    ImageList1: TImageList;
    EditNewAddressAgain: TEdit;
    pnlShowFromString: TPanel;
    lblRepType: TLabel;
    lblRepItem: TLabel;
    pmListView: TPopupMenu;
    Toggle1: TMenuItem;
    Yes1: TMenuItem;
    No1: TMenuItem;
    DdeClientConv1: TDdeClientConv;
    N1: TMenuItem;
    WhatsThis2: TMenuItem;
    btnBrowseDirFrom: TBitBtn;
    btnBrowseFileFrom: TBitBtn;
    btnBrowseFileTo: TBitBtn;
    btnBrowseDirTo: TBitBtn;
    cbShowAll: TCheckBox;
    Panel2: TPanel;
    BtnHelp: TBitBtn;
    BtnAbout: TBitBtn;
    Bevel1: TBevel;
    NotebookSub: TNotebook;
    lblSearchType: TLabel;
    lblSearchIn: TLabel;
    lblFoundINI: TLabel;
    lblFoundGroup: TLabel;
    lblFoundShortcut: TLabel;
    lblFoundReg: TLabel;
    BtnSaveList: TBitBtn;
    BtnPrev: TBitBtn;
    BtnNext: TBitBtn;
    BtnCancel: TBitBtn;
    lbReport: TListBox;
    btnSaveLog: TBitBtn;
    SaveDialog2: TSaveDialog;
    btnInputOk: TBitBtn;
    btnInputBad: TBitBtn;
    btnInputHmm: TBitBtn;
    procedure BtnAboutClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure BtnPrevClick(Sender: TObject);
    procedure BtnNextClick(Sender: TObject);
    procedure NotebookMainPageChanged(Sender: TObject);
    procedure WhatsThis1Click(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnBrowseDirFromClick(Sender: TObject);
    procedure btnBrowseDirToClick(Sender: TObject);
    procedure btnBrowseFileFromClick(Sender: TObject);
    procedure btnBrowseFileToClick(Sender: TObject);
    procedure EditOldAddressChange(Sender: TObject);
    procedure cbSkipIgnoreKeysClick(Sender: TObject);
    procedure lvFoundColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvFoundCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure lvFoundDblClick(Sender: TObject);
    procedure BtnSaveListClick(Sender: TObject);
    procedure lvFoundMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Toggle1Click(Sender: TObject);
    procedure lvFoundKeyPress(Sender: TObject; var Key: Char);
    procedure WhatsThis2Click(Sender: TObject);
    procedure NotebookSubPageChanged(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditToStringAgainChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnSaveLogClick(Sender: TObject);
    procedure btnInputBadClick(Sender: TObject);
  private
    { Private declarations }
    KeyWasF1,
    CleaningRegistry    : Boolean;
    InputRating,
    ItemsINI, ItemsGRP,
    ItemsLNK, ItemsReg,
    lvSortCol          : Integer;
    lvSortRev          : Boolean;
    vSearchType        : Integer;
    CurrentItems       : ^Integer;
    SkipCBs            : ARRAY[nbFirstPage..nbLastPage] OF TCheckBox;
    lvMouseX, lvMouseY : Integer;
    ActiveThread       : TCOAThread;
    ReptBoxWidth       : Integer;
    function AppOnHelp(Command: Word; Data: Longint;
      VAR CallHelp : Boolean): Boolean;
    procedure AddAnItem(const cItem, cPath,
      cContext : String; vType, vSubType  : Integer);
    procedure SearchIniFiles;
    procedure SearchGrpFiles(Sender: TObject);
    procedure SearchShortcuts(Sender: TObject);
    procedure SearchRegistry(Sender: TObject);
    procedure SearchDone(Sender: TObject);
    procedure SaveListViewAsRTF(CONST name : String);
    procedure Report(const S : String);
    procedure StartReplacing;
    function DeAmp(const S : String) : String;
    function HelpForItemAt(P : TPoint) : Integer;
    procedure wmGetMinMaxInfo(VAR Msg: TWMGetMinMaxInfo);
      message WM_GETMINMAXINFO;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Ole2, Registry, FileCtrl, AboutB32, CoaGenl, Thd_Ini,
  Thd_Grp, Thd_Lnk, Thd_Reg;

{$I HELPCTX.PAS}
{$R *.DFM}
{$R COASTRNG.RES}

procedure TForm1.wmGetMinMaxInfo(VAR Msg: TWMGetMinMaxInfo);
begin
  Msg.MinMaxInfo^.PtMinTrackSize := Point(540,312);
end;

procedure TForm1.BtnAboutClick(Sender: TObject);
begin
  WITH TAboutForm.Create(Application) DO
    try      ShowModal;
    finally  Free;
    end;
end;

procedure TForm1.BtnHelpClick(Sender: TObject);
begin
  IF NoteBookMain.PageIndex = 7 THEN
    WITH NotebookSub, Pages.Objects[PageIndex] AS TPage DO
      Application.HelpContext(HelpContext)
  ELSE
    WITH NotebookMain, Pages.Objects[PageIndex] AS TPage DO
      Application.HelpContext(HelpContext);
end;

procedure TForm1.BtnNextClick(Sender: TObject);
VAR NewIndex : Integer;
begin
  btnPrev.Enabled := True;
  // If in Search page, work with subnotebook
  IF (NotebookMain.PageIndex = nbPgSearch) AND
     (NotebookSub.PageIndex <> nbSbSearched) THEN
    NotebookSub.pageIndex := Succ(NotebookSub.PageIndex)
  ELSE
    WITH NotebookMain DO
      BEGIN
        // go to next page
        NewIndex := PageIndex + 1;
        // skip any pages with skip-box checked
        WHILE (NOT cbShowAll.Checked) AND Assigned(SkipCBs[NewIndex])
          AND SkipCBs[NewIndex].Checked DO
            NewIndex := NewIndex + 1;
        PageIndex := NewIndex;
        // perform any initialization required on reaching new page
        CASE PageIndex OF
          nbPgFromAndTo : EditOldAddressChange(EditOldAddress);
          nbPgSearch    : begin
            btnPrev.Enabled := False; // can't go back
            btnNext.Enabled := False;
            // next two lines used to occur upon arrival at
            // nbPgIniFiles - but that's pointless. Better to happen
            // on arrival at no-turning-back nbPgSearch.
            pnlShowFromString.Caption := EditOldAddress.Text;
            EditNewAddressAgain.Text := EditNewAddress.Text;
            EditNewAddressAgain.OnChange :=
              EditToStringAgainChange;
            SearchIniFiles;
          end;
          nbPgFinalPage : begin
            btnNext.Enabled := EditNewAddressAgain.Text <> '';
          end;
          nbPgReplacing : begin
            btnNext.Enabled := False;     // can't go forward
            btnPrev.Enabled   := False;   // can't go back
            BtnCancel.Enabled := False;   // can't quit
            BtnCancel.Caption := 'Close'; // can't cancel
            Application.ProcessMessages;
            StartReplacing;
          end;
        end;
      END;
end;

procedure TForm1.BtnPrevClick(Sender: TObject);
VAR NewIndex : Integer;
begin
  BtnNext.Enabled := True;
  // If in Search page, work with subnotebook
  IF (NotebookMain.PageIndex = nbPgSearch) AND
     (NotebookSub.PageIndex <> nbSbSearching) THEN
    begin
      NotebookSub.pageIndex := Pred(NotebookSub.pageIndex);
      btnPrev.Enabled := NoteBookSub.PageIndex = nbSbSearched;
    end
  ELSE
    begin
{      // if leaving "final" page, restore Next button's name
      IF NotebookMain.PageIndex = nbPgFinalPage THEN
         btnNext.Caption := 'Next >';}(*!*)
      WITH NotebookMain DO
        BEGIN
          // go to previous page
          NewIndex := PageIndex - 1;
          // skip (backward) any pages with skip-box checked
          WHILE (NOT cbShowAll.Checked) AND Assigned(SkipCBs[NewIndex])
            AND SkipCBs[NewIndex].Checked DO
              NewIndex := NewIndex - 1;
          PageIndex := NewIndex;
          IF PageIndex = nbFirstPage THEN
            btnPrev.Enabled := False;
        END;
    end;
end;

function TForm1.DeAmp(const S : String) : String;
// Remove ampersands
VAR Posn : Integer;
begin
  Result := S;
  Posn := Pos('&', Result);
  WHILE Posn <> 0 DO
    begin
      Delete(Result, Posn, 1);
      Posn := Pos('&', Result);
    end;
end;

procedure TForm1.NotebookMainPageChanged(Sender: TObject);
// when a page becomes current, make a particular control active
begin
  CASE NotebookMain.PageIndex OF
    nbPgFromAndTo  : ActiveControl := EditOldAddress;
    nbPgIniFiles   : ActiveControl := rgIniFiles;
    nbPgGroups     : ActiveControl := rgGroups;
    nbPgShortcuts  : ActiveControl := rgShortcuts;
    nbPgRegistry   : ActiveControl := rgRegistry;
    nbPgIgnoreKeys : ;
    nbPgConfirm    : begin
      lblFrom.Caption    := EditOldAddress.Text;
      lblTo.Caption      := EditNewAddress.Text;
      lblReplace.Visible := EditNewAddress.Text <> '';
      lblIni.Caption     :=
        DeAmp(rgIniFiles.Items[rgIniFiles.ItemIndex]);
      lblGroup.Caption   :=
        DeAmp(rgGroups.Items[rgGroups.ItemIndex]);
      lblShortcut.Caption:=
        DeAmp(rgShortcuts.Items[rgShortcuts.ItemIndex]);
      lblRegistry.Caption:=
        DeAmp(rgRegistry.Items[rgRegistry.ItemIndex]);
    end;
    nbPgSearch : ActiveControl := lvFound;
    nbPgFinalPage : ActiveControl := EditNewAddressAgain;
  END;
  // what's this help for notebook should relate to current page
  WITH NotebookMain DO
    HelpContext := TPage(Pages.Objects[PageIndex]).HelpContext;
end;

procedure TForm1.WhatsThis1Click(Sender: TObject);
begin
  IF pmWhatsThis.PopupComponent IS TWinControl THEN
    Application.HelpCommand(HELP_CONTEXTPOPUP,
      TWinControl(pmWhatsThis.PopupComponent).HelpContext)
  ELSE Application.HelpCommand(HELP_CONTEXT, 0);
end;

function TForm1.HelpForItemAt(P : TPoint) : Integer;
CONST
  TypString = '^INI^GRP^LNK^REG^';
VAR
  TypI, SubI : Integer;
  lvItem     : TListItem;
begin
  IF (P.X<0) OR (P.Y<0) THEN
    begin
      GetCursorPos(P);
      P := lvFound.ScreenToClient(P);
    end;
  lvItem := lvFound.GetItemAt(4, P.Y);
  Result := lvFound.HelpContext;
  IF lvItem = NIL THEN Exit;
  WITH lvItem DO
    begin
      TypI := Pos('^'+SubItems[1]+'^', TypString);
      IF TypI <> 0 THEN TypI := ((TypI - 1) DIV 4) + 1;
      TObject(SubI) := Data;
      CASE TypI OF
        stINI : CASE SubI OF
                  sitSection   : Result := lvch_INIsec;
                  sitKey       : Result := lvch_INIkey;
                END;
        stGRP : CASE SubI OF
                  sitCommand   : Result := lvch_GRPcmd;
                  sitIconLoc   : Result := lvch_GRPico;
                  sitWorkDir   : Result := lvch_GRPwrk;
                END;
        stLNK : CASE SubI OF
                  sitCommand   : Result := lvch_LNKcmd;
                  sitIconLoc   : Result := lvch_LNKico;
                  sitWorkDir   : Result := lvch_LNKwrk;
                  sitArguments : Result := lvch_LNKarg;
                END;
        stREG : CASE SubI OF
                  sitKey       : Result := lvch_REGkey;
                  sitValue     : Result := lvch_REGval;
                  sitData      : Result := lvch_REGdat;
                  //1.01
                  sitDatEx     : Result := lvch_REGdat;
                  //1.01
                END;
      end;
    end;
end;

procedure TForm1.WhatsThis2Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTEXTPOPUP,
    HelpForItemAt(Point(lvMouseX, lvMouseY)));
end;

procedure TForm1.BtnCancelClick(Sender: TObject);
begin
  IF Assigned(ActiveThread) THEN
    ActiveThread.Terminate;
  Close;
end;

function TForm1.AppOnHelp(Command: Word; Data: Longint;
  VAR CallHelp : Boolean): Boolean;
begin
  Result := False;
  IF Command = HELP_CONTEXTPOPUP THEN
    begin
      IF KeyWasF1 THEN
        begin
          KeyWasF1 := False;
          CallHelp := False;
          btnHelpClick(btnHelp);
        end
      ELSE
        CASE Data OF
          ch_ListView1 : begin
            Data := HelpForItemAt(Point(-1,-1));
            IF Data = ch_ListView1 THEN CallHelp := True
            ELSE Application.HelpCommand(HELP_CONTEXTPOPUP, Data);
          end;
          ch_btnAbout..ch_lbIgnoreKeys,
          ch_btnSave..lvch_REGdat,
          ch_lbReport..ch_btnInputHmmm : CallHelp := True;
          ELSE
            BEGIN
              CallHelp := False;
              Result := Application.HelpCommand(HELP_CONTEXT, Data);
            END
        END;
    end;
end;

function CurrentUserSID(VAR theSID : String) : Integer;
// Calculate the Security ID for the current user, to
//  determine which branch of HKEY_USERS is HKEY_CURRENT_USER
VAR
  UserName : ARRAY[0..MAX_PATH] OF Char;
  UserLeng : DWORD;
  DomaName : ARRAY[0..MAX_PATH] OF Char;
  DomaLeng : DWORD;
  SID      : ARRAY[0..1000] OF Byte;
  SIDLeng  : DWORD;
  SIDuse   : DWORD;
  PSIA     : PSIDIdentifierAuthority;
  N        : Integer;
  NumSubs  : PUChar;
  OneSub   : PDWORD;
begin
  UserLeng := MAX_PATH;
  Result := 1;
  IF NOT GetUserName(UserName, UserLeng) THEN Exit;
  DomaLeng := MAX_PATH;
  Result := 2;
  SidLeng := 1000;
  IF NOT LookupAccountName(NIL, UserName, @SID, SIDLeng,
    DomaName, DomaLeng, SidUse) THEN Exit;
  TheSid := 'S-1-';
  Result := 3;
  SetLastError(0);
  PSIA := GetSidIdentifierAuthority(@SID);
  IF GetLastError <> 0 THEN Exit;
  WITH PSIA^ do
    IF (Value[0]<>0) OR (Value[1]<>0) THEN
      TheSid := Format('%s0x%.2x%.2x%.2x%.2x%.2x%.2x-',
        [TheSid, Value[0], Value[1], Value[2], Value[3],
        Value[4], Value[5]])
    else
      begin
        N := Value[2] SHL 8;
        N := (N + Value[3]) SHL 8;
        N := (N + Value[4]) SHL 8;
        N := N + Value[5];
        TheSid := Format('%s%d', [TheSid, N]);
      end;
  Result := 4;
  NumSubs := GetSidSubAuthorityCount(@SID);
  IF GetLastError <> 0 THEN Exit;
  FOR N := 0 TO NumSubs^-1 DO
    begin
      Result := N + 5;
      OneSub := GetSidSubAuthority(@SID, N);
      IF GetLastError <> 0 THEN Exit;
      TheSid := Format('%s-%d', [TheSid, OneSub^]);
    end;
  Result := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
VAR S : String;

  function IsCleaning : Boolean;
  begin
    Result := False;
    IF (ParamCount > 0) AND
       (AnsiCompareText(ParamStr(1), 'CleanRegistry') = 0) THEN
      WITH TRegistry.Create DO
        try
          OpenKey('Software\PC Magazine\COA32', False);
          DeleteKey('1.0');
          CleaningRegistry := True;
          Result := True;
        finally
          Free;
          PostQuitMessage(0);
        end;
  end;

begin
  IF IsCleaning THEN Exit;
  // do this so listview's size can track window's
  lvFound.HandleNeeded;
  Application.HelpFile := ChangeFileExt(Application.ExeName, '.HLP');
  Application.OnHelp      := AppOnHelp;
  NotebookMain.PageIndex  := 0;
  NotebookSub.PageIndex   := 0;
  SkipCBs[nbPgIniFiles]   := cbSkipIniFiles;
  SkipCBs[nbPgGroups]     := cbSkipGroups;
  SkipCBs[nbPgShortcuts]  := cbSkipShortcuts;
  SkipCBs[nbPgRegistry]   := cbSkipRegistry;
  SkipCBs[nbPgIgnoreKeys] := cbSkipIgnoreKeys;
  WITH TRegIniFile.Create(COA32Key) DO
    try
      rgIniFiles.ItemIndex := ReadInteger('Settings', 'INI Files',2);
      rgGroups.ItemIndex := ReadInteger('Settings', 'Groups', 1);
      rgShortcuts.ItemIndex := ReadInteger('Settings', 'Shortcuts',
        Integer(NTVersion <> NT351));
      rgRegistry.ItemIndex := ReadInteger('Settings', 'Registry', 2);
      WITH cbSkipIniFiles DO
        Checked := ReadInteger('Skip Pages', 'INI Files', 0) = 1;
      WITH cbSkipGroups DO
        Checked := ReadInteger('Skip Pages', 'Groups', 0) = 1;
      WITH cbSkipShortcuts DO
        Checked := ReadInteger('Skip Pages', 'Shortcuts', 0) = 1;
      WITH cbSkipRegistry DO
        Checked := ReadInteger('Skip Pages', 'Registry', 0) = 1;
      // Create this key if it doesn't exist, so users will have
      // someplace to "hang" keys that should be ignored
      OpenKey('Registry Keys To Ignore', TRUE);
      GetValueNames(lbIgnoreKey.Items);
    finally
      free;
    end;
   // This key is equivalent to HKEY_CLASSES_ROOT in Win95 or NT
  lbIgnoreKey.Items.Insert(0, 'HKLM\SOFTWARE\CLASSES');
  WITH TRegistry.Create DO
    try
      IF NTVersion > NotNT THEN
        begin
          RootKey := HKEY_USERS;
          OpenKey('', FALSE);
          // This key is equivalent to HKEY_CURRENT_USER in WinNT
          IF (CurrentUserSID(S)=0) AND KeyExists(S) THEN
            lbIgnoreKey.Items.Insert(0, 'HKUS\'+S);
          // Ignore this key, as it is volatile
          lbIgnoreKey.Items.Insert(0, 'HKLM\Hardware');
          // Ignore this key, as it is not permitted
          lbIgnoreKey.Items.Insert(0, 'HKLM\Security');
          // Ignore this key, as it is not permitted
          lbIgnoreKey.Items.Insert(0, 'HKLM\SAM');
        end
      else
        begin
          RootKey := HKEY_LOCAL_MACHINE;
          OpenKey('\System\CurrentControlSet\control', False);
          S := ReadString('Current User');
          // This key is equivalent to HKEY_CURRENT_USER in Win95
          lbIgnoreKey.Items.Insert(0, 'HKUS\'+UpperCase(S));
          OpenKey('IDConfigDB', False);
          S := ReadString('CurrentConfig');
          // This key is equivalent to HKEY_CURRENT_CONFIG, which
          // is only documented in Win95
          lbIgnoreKey.Items.Insert(0, 'HKLM\CONFIG\' +
            UpperCase(S));
          (*!*) // No info from MS about HKEY_CURRENT_CONFIG in NT4
        end;
    finally
      Free;
    end;
  IF NTVersion <> NotNT THEN
    begin
      // disable option that includes HKEY_CURRENT_CONFIG
      WITH rgRegistry.Controls[2] AS TRadioButton DO
        Enabled := False;
      IF rgRegistry.ItemIndex = 2 THEN
        rgRegistry.ItemIndex := 1;
    end;
  IF NTVersion = NT351 THEN
    begin
      // hide shortcuts page, as this is NT 3.51
      cbSkipShortcuts.Checked := True;
      rgShortcuts.ItemIndex := 0;
      // disable all shortcut options except "None"
      WITH rgShortCuts.Controls[1] AS TRadioButton DO
        Enabled := False;
      WITH rgShortCuts.Controls[2] AS TRadioButton DO
        Enabled := False;
      WITH rgShortCuts.Controls[3] AS TRadioButton DO
        Enabled := False;
    end
  else
    begin
      // hide Groups page as this is not NT 3.51
      cbSkipGroups.Checked := True;
      rgGroups.ItemIndex := 0;
      // disable option to search groups
      WITH rgGroups.Controls[1] AS TRadioButton DO
        Enabled := False;
    end;
  SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  ActiveControl := EditOldAddress;
  InputRating := riNoAddress;
end;

procedure TForm1.FormClose(Sender: TObject; var Action:TCloseAction);
begin
  IF CleaningRegistry THEN
    BEGIN
      Action := caFree;
      Exit;
    END;
  WITH TRegIniFile.Create(COA32Key) DO
    try
      WriteInteger('Settings', 'INI Files', rgIniFiles.ItemIndex);
      WriteInteger('Settings', 'Groups', rgGroups.ItemIndex);
      WriteInteger('Settings', 'Shortcuts', rgShortcuts.ItemIndex);
      WriteInteger('Settings', 'Registry', rgRegistry.ItemIndex);
      WITH cbSkipIniFiles DO
        WriteInteger('Skip Pages', 'INI Files', Integer(Checked));
      WITH cbSkipGroups DO
        WriteInteger('Skip Pages', 'Groups', Integer(Checked));
      WITH cbSkipShortcuts DO
        WriteInteger('Skip Pages', 'Shortcuts', Integer(Checked));
      WITH cbSkipRegistry DO
        WriteInteger('Skip Pages', 'Registry', Integer(Checked));
    finally
      Free;
    end;
  Application.HelpCommand(HELP_QUIT, 0);
end;

procedure TForm1.btnBrowseDirFromClick(Sender: TObject);
VAR S : String;
begin
  S := EditOldAddress.Text;
  IF SelectDirectory(S, [], Folder_Browse_Button) THEN
    begin
      //1.01 - now defaults to NO backslash
      IF (Length(S)>3) AND (S[Length(S)] = '\') THEN
        S := System.Copy(S, 1, Pred(Length(S)));
      EditOldAddress.Text := S;
    end;
end;

procedure TForm1.btnBrowseDirToClick(Sender: TObject);
VAR S : String;
begin
  S := EditNewAddress.Text;
  IF SelectDirectory(S, [], Folder_Browse_Button) THEN
    begin
      //1.01 - now defaults to NO backslash
      IF (Length(S)>3) AND (S[Length(S)] = '\') THEN
        S := System.Copy(S, 1, Pred(Length(S)));
      EditNewAddress.Text := S;
    end;
end;

procedure TForm1.btnBrowseFileFromClick(Sender: TObject);
begin
  WITH OpenDialog1 DO
    begin
      HelpContext := File_Browse_Button;
      Title := 'Filename for Old address';
      Filename := EditOldAddress.Text;
      IF Execute THEN EditOldAddress.Text := Filename;
    end;
end;

procedure TForm1.btnBrowseFileToClick(Sender: TObject);
begin
  WITH OpenDialog1 DO
    begin
      HelpContext := File_Browse_Button;
      Title := 'Filename for New address';
      Filename := EditNewAddress.Text;
      IF Execute THEN EditNewAddress.Text := Filename;
    end;
end;


procedure TForm1.EditOldAddressChange(Sender: TObject);
  procedure RateInput(const S1, S2 : String);
  VAR
    Stat1, Stat2 : Integer;
    Drv1, Drv2 : String[2];
    LC1, LC2 : Char;
  begin
    InputRating := riNoAddress;
    IF S1 = '' THEN Exit;
    InputRating := riOldShort;
    IF (Length(S1) < 4) THEN Exit;
    InputRating := riOKNoNew;
    IF S2 = '' THEN Exit;
    InputRating := riNewShort;
    IF (Length(S2) < 4) THEN Exit;
    Stat1 := 0; Stat2 := 0;
    IF FileExists(S1) THEN Stat1 := 1;
    IF DirectoryExists(S1) THEN Stat1 := 2;
    IF FileExists(S2) THEN Stat2 := 10;
    IF DirectoryExists(S2) THEN Stat2 := 20;
    InputRating := riOK;
    CASE Stat1 + Stat2 OF
      00 : InputRating := riNeither;
      01 : ;
      02 : ;
      10 : ;
      11 : InputRating := riBothFile;
      12 : InputRating := riFileDir;
      20 : ;
      21 : InputRating := riDirFile;
      22 : InputRating := riBothDir;
    END;
    IF InputRating <> riOK THEN Exit;
    IF (Length(S1)>2) AND (Length(S2)>2) THEN
      begin
        InputRating := riNoBothDrv;
        Drv1 := Copy(S1, 2, 2);
        Drv2 := Copy(S2, 2, 2);
        IF (Drv1=':\') XOR (Drv2=':\') THEN Exit;
      end;
    InputRating := riNoBothExt;
    IF (Stat1=1) AND (ExtractFileExt(S1)<>'.') AND
      (ExtractFileExt(S2)='.') THEN Exit;
    IF (Stat2=10) AND (ExtractFileExt(S2)<>'.') AND
      (ExtractFileExt(S1)='.') THEN Exit;
    LC1 := S1[Length(S1)]; LC2 := S2[Length(S2)];
    InputRating := riNoBothSlash;
    IF (LC1='\') XOR (LC2='\') THEN Exit;
    InputRating := riNoBothDot;
    IF (LC1='.') XOR (LC2='.') THEN Exit;
    InputRating := riOK;
  end;
begin
  btnNext.Enabled := (EditOldAddress.Text <> '');
  RateInput(EditOldAddress.Text, EditNewAddress.Text);
  CASE InputRating OF
    riOK..riOKNoNew          : btnInputOk.BringToFront;
    riOldShort..riBothDir    : btnInputHmm.BringToFront;
    riNoAddress..riNoBothDot : btnInputBad.BringToFront;
  END;
end;

procedure TForm1.cbSkipIgnoreKeysClick(Sender: TObject);
// Don't disable box, but don't let it be unchecked either
begin
  (Sender AS TCheckBox).Checked := True;
end;

procedure TForm1.AddAnItem(const cItem, cPath, cContext : String;
  vType, vSubType  : Integer);
// called by threads to add an item to "found" list
begin
  IF Application.Terminated THEN Exit;
  IF lvFound.Items.Count=1 THEN
    IF lvFound.Items[0].Caption = '<none>' THEN
      lvFound.Items.Delete(0);
  WITH lvFound.Items.Add DO
    begin
      Caption    := cItem;
      StateIndex := vType;
      Data       := Pointer(vSubType);
      SubItems.Add(cPath);
      SubItems.Add(SearchExts[vType]);
      SubItems.Add(SITNames[vSubType]);
      SubItems.Add(cContext);
    end;
  Inc(CurrentItems^);
end;

procedure TForm1.SearchIniFiles;
begin
  Screen.Cursor := crHourglass;
  IF rgIniFiles.ItemIndex = 0 THEN
    begin
      ItemsINI := -1;
      SearchGrpFiles(NIL);
      Exit;
    end;
  ItemsINI := 0;
  CurrentItems := @ItemsINI;
  lblSearchType.Caption := 'Searching ' + lblINI.Caption;
  CASE rgIniFiles.ItemIndex OF
    1  : vSearchType := srchSpecial;
    2  : vSearchType := srchWinDir;
    3  : vSearchType := srchWinDirAnd;
    4  : vSearchType := srchAll;
    ELSE vSearchType := srchNone;
  END;
  ActiveThread := TSearchIniThread.Create(stINI, EditOldAddress.Text,
    lblSearchIn, AddAnItem, vSearchType);
  ActiveThread.OnTerminate := SearchGrpFiles;
  ActiveThread.Resume;
end;

procedure TForm1.SearchGrpFiles(Sender: TObject);
begin
  IF Application.Terminated THEN Exit;
  IF rgGroups.ItemIndex = 0 THEN
    begin
      ItemsGRP := -1;
      SearchShortcuts(NIL);
      Exit;
    end;
  ItemsGRP := 0;
  CurrentItems := @ItemsGRP;
  lblSearchType.Caption := 'Searching ' + lblGroup.Caption;
  lblSearchIn.Caption := '';
  ddeClientConv1.SetLink('ProgMan','ProgMan');
  ddeClientConv1.OpenLink;
  ActiveThread := TSearchGrpThread.Create(stGRP, EditOldAddress.Text,
    lblSearchIn, AddAnItem, ddeClientConv1);
  ActiveThread.OnTerminate := SearchShortcuts;
  ActiveThread.Resume;
end;

// figure 6 begin
procedure TForm1.SearchShortcuts(Sender: TObject);
begin
  IF Application.Terminated THEN Exit;
  IF rgShortcuts.ItemIndex = 0 THEN
    begin
      ItemsLNK := -1;
      SearchRegistry(NIL);
      Exit;
    end;
  ItemsLNK := 0;
  CurrentItems := @ItemsLNK;
  lblSearchType.Caption := 'Searching '+ lblShortcut.Caption;
  lblSearchIn.Caption := '';
  CASE rgShortcuts.ItemIndex OF
    1  : vSearchType := srchSpecial;
    2  : vSearchType := srchWinDirAnd;
    3  : vSearchType := srchAll;
    ELSE vSearchType := srchNone;
  END;
  ActiveThread := TSearchLnkThread.Create(stLNK, EditOldAddress.Text,
    lblSearchIn, AddAnItem, vSearchType);
  ActiveThread.OnTerminate := SearchRegistry;
  ActiveThread.Resume;
end;
// figure 6 end

procedure TForm1.SearchRegistry(Sender: TObject);
begin
  IF Application.Terminated THEN Exit;
  IF rgRegistry.ItemIndex = 0 THEN
    begin
      ItemsReg := -1;
      SearchDone(NIL);
      Exit;
    end;
  ItemsReg := 0;
  CurrentItems := @ItemsReg;
  lblSearchType.Caption := 'Searching '+lblRegistry.Caption;
  lblSearchIn.Caption := '';
  CASE rgRegistry.ItemIndex OF
    1  : vSearchType := srchRegHKCRHKCU;
    2  : vSearchType := srchRegHKCCToo;
    3  : vSearchType := srchRegAll;
    ELSE vSearchType := srchNone;
  END;
  ActiveThread := TSearchRegThread.Create(stREG, EditOldAddress.Text,
    lblSearchIn, AddAnItem, lbIgnoreKey.Items, vSearchType);
  ActiveThread.OnTerminate := SearchDone;
  ActiveThread.Resume;
end;

procedure TForm1.SearchDone(Sender: TObject);
begin
  IF Application.Terminated THEN Exit;
  DdeClientConv1.CloseLink;
  ActiveThread := NIL;
  WITH lblFoundINI DO
    IF ItemsINI = -1 THEN
      Caption := 'No INI files searched'
    ELSE
      Caption := Format('%d matches in INI files', [ItemsINI]);
  WITH lblFoundGroup DO
    IF ItemsGRP = -1 THEN
      Caption := 'No Groups searched'
    ELSE
      Caption := Format('%d matches in Groups', [ItemsGRP]);
  WITH lblFoundShortcut DO
    IF ItemsLNK = -1 THEN
      Caption := 'No Shortcuts searched'
    ELSE
      Caption := Format('%d matches in Shortcuts', [ItemsLNK]);
  WITH lblFoundReg DO
    IF ItemsReg = -1 THEN
      Caption := 'No Registry entries searched'
    ELSE
      Caption := Format('%d matches in the Registry', [ItemsReg]);
  NotebookSub.PageIndex := nbSbSearchResults;
  btnNext.Enabled := (ItemsINI > 0) OR (ItemsGRP > 0) OR
    (ItemsLNK > 0) OR (ItemsREG > 0);
  btnPrev.Enabled := False;
  Screen.Cursor := crDefault;
end;

procedure TForm1.lvFoundColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  IF lvSortCol = Column.Index THEN
    lvSortRev := NOT lvSortRev
  ELSE lvSortRev := FALSE;
  lvSortCol := Column.Index;
  lvFound.AlphaSort;
end;

procedure TForm1.lvFoundCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
begin
  IF lvSortCol < 0 THEN // special sort prior to replacing
    begin // Type first
      lvSortRev := False;
      Compare := AnsiCompareStr(Item1.SubItems[1],
        Item2.SubItems[1]);
      IF Compare = 0 THEN
        begin // Path next
          Compare := AnsiCompareStr(Item1.SubItems[0],
            Item2.SubItems[0]);
          IF Compare = 0 THEN // Item next
            Compare := AnsiCompareStr(Item1.Caption, Item2.Caption);
        end;
    end
  ELSE IF lvSortCol = 0 THEN
    Compare := AnsiCompareStr(Item1.Caption, Item2.Caption)
  ELSE
    Compare := AnsiCompareStr(Item1.SubItems[lvSortCol-1],
      Item2.SubItems[lvSortCol-1]);
  IF lvSortRev THEN Compare := -Compare;
end;

procedure TForm1.lvFoundDblClick(Sender: TObject);
VAR lvItemAt : TListItem;
begin
  lvItemAt := lvFound.GetItemAt(4{lvMouseX}, lvMouseY);
  IF lvItemAt = NIL THEN Exit;
  WITH lvItemAt DO
    begin
      ImageIndex := ImageIndex XOR 1;
      Update;
    end;
end;

procedure TForm1.SaveListViewAsRTF(CONST name : String);
// Write a bare-minimum RTF file containing found items
// in the form of a table
VAR
  TF : TextFile;
  N  : Integer;

  function Fix(const S : String) : String;
  // insert backslash before special characters
    procedure FixOneChar(VAR S : String; C : Char);
    VAR
      P : PChar;
      Loc : Integer;
    begin
      Loc := -1;
      WHILE True DO
        begin
          P := PChar(Result) + Loc + 1;
          P := StrScan(P, C);
          IF P = NIL THEN Break;
          Loc := P-PChar(Result)+1;
          System.Insert('\', Result, Loc);
        end;
    end;
  begin
    Result := S;
    FixOneChar(Result, '\'); // must come first
    FixOneChar(Result, '{');
    FixOneChar(Result, '}');
  end;

begin
  AssignFile(TF, Name);
  Rewrite(TF);
  WriteLn(TF, '{\rtf1\ansi\widowctrl\fs32');
  WriteLn(TF, '{\info{\title Items containing "'+EditOldAddress.Text
    +'"}');
  WriteLn(TF, '{\author COA 32, a PC Magazine utility}');
  WriteLn(TF, '{\comment This is just a comment}}');
  WriteLn(TF, '{\header \tqc\tx4320\tqr\tx8640');
  WriteLn(TF, '\chdate \tab COA32 Report \tab \chpgn \par');
  Write(TF, '\tab Seeking text "'+Fix(EditOldAddress.Text));
  WriteLn(TF, '" \par}\pard\fs20');
  WriteLn(TF, '\intbl\trowd\cellx1440\cellx3600\cellx4320\'+
    'cellx5760\cellx9540 ');
  WriteLn(TF, '{\b Item\cell Path\cell Type\cell SubType\cell'+
    ' Context\cell} \row');
  FOR N := 0 TO lvFound.Items.Count-1 DO
    WITH lvFound.Items[N] DO
      IF ImageIndex = 0 THEN
        begin
          WriteLn(TF, '\trowd\cellx1440\cellx3600\cellx4320\'+
            'cellx5760\cellx9540 ');
          WriteLn(TF, Format('%s\cell %s\cell %s\cell %s\cell '+
            '%s\cell \row', [Fix(Caption), Fix(SubItems[0]),
            Fix(SubItems[1]), Fix(SubItems[2]), Fix(SubItems[3])]));
        end;
  Write(TF, '}');
  CloseFile(TF);
end;

procedure TForm1.BtnSaveListClick(Sender: TObject);
begin
  WITH SaveDialog1 DO
    IF Execute THEN
      SaveListViewAsRTF(Filename);
end;

procedure TForm1.lvFoundMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lvMouseX := X;
  lvMouseY := Y;
end;

procedure TForm1.Report(const S : String);
VAR W : Integer;
begin
  W := lbReport.Canvas.TextWidth(S);
  lbReport.Items.Add(S);
  IF W > ReptBoxWidth THEN
    begin
      ReptBoxWidth := W;
      lbReport.Perform(LB_SETHORIZONTALEXTENT, ReptBoxWidth, 0);
    end;
end;

procedure TForm1.StartReplacing;
VAR
  S, Fnd, Rep  : String;
  RepLists     : ARRAY[stINI..stREG] OF TStringList;
  DdeCommands  : TStringList;
  N            : Integer;

  function MakePath(const vPath, vItem : String) : String;
  begin
    IF vPath[length(vPath)] = '\' THEN
      Result := vPath + vItem
    ELSE Result := vPath + '\' + vItem;
  end;

begin
  lbReport.Clear;
  lbReport.Items.Add('Report generated by COA 32 on '+
    FormatDateTime('dddd, mmmm d, yyyy  hh:mm AM/PM', Now));
  lbReport.Items.Add('(Error lines begin with *****)');
  Fnd := EditOldAddress.Text;
  Rep := EditNewAddressAgain.Text;
  lbReport.Items.Add('Old address: ' + Fnd);
  lbReport.Items.Add('New address: ' + Rep);
  Screen.Cursor := crHourglass;
  try
    // Eliminate "N" items
    FOR N := lvFound.Items.Count-1 DOWNTO 0 DO
      IF lvFound.Items[N].ImageIndex <> 0 THEN
        lvFound.Items.Delete(N);
    // Sort by type, path, and item
    lvSortCol := -1;
    lvFound.AlphaSort;
    FOR N := stINI to stREG DO
      RepLists[N] := TStringList.Create;
    try
      // Put each distinct item (e.g. Group, INI file) in
      // a list. Put subitems (e.g. group item working dir,
      // INI file key) in a tstringlist that's associated
      // with the distinct item.
      FOR N := 0 TO lvFound.Items.Count-1 DO
        WITH lvFound.Items[N] DO
          begin
            // For REG and GRP, distinct item is path
            // For INI and LNK, distinct item is path\Item
            CASE StateIndex OF
              stREG : S := SubItems[0];
              stGRP : S := SubItems[0];
              ELSE    S := MakePath(SubItems[0], Caption);
            END;
            WITH RepLists[StateIndex] DO
              begin
                // Add distinct item to list if not present
                IF (Count=0) OR (Strings[Count-1] <> S) THEN
                  AddObject(S, TStringList.Create);
                // Subitem is context for REG, item for GRP,
                // uppercase CONTEXT for INI and LNK. In each
                // case, subtype is stored as object with subitem.
                WITH Objects[Count-1] AS TStringList DO
                  CASE StateIndex OF
                    stREG : AddObject(SubItems[3], Data);
                    stGrp : AddObject(Caption, Data);
                    ELSE AddObject(UpperCase(SubItems[3]), Data);
                  END;
              end;
          end;
      lblRepType.Caption := 'in INI files';
      ReplaceINI(RepLists[stINI], Fnd, Rep, lblRepItem, Report);
      lblRepType.Caption := 'in Groups';
      DdeCommands := TStringList.Create;
      ReplaceGRP(RepLists[stGRP], Fnd, Rep, lblRepItem, Report,
        DdeClientConv1, DdeCommands);
      IF (DdeCommands.Count > 0) THEN
        WITH DdeClientConv1 DO
          begin
            SetLink('ProgMan','ProgMan');
            OpenLink;
            IF ExecuteMacroLines(DdeCommands, True) THEN
              FOR N := 0 TO 100 DO
                begin
                  Application.ProcessMessages;
                  IF NOT WaitStat THEN Break;
                end;
          end;
      DdeCommands.Free;
      lblRepType.Caption := 'in Shortcuts';
      ReplaceLNK(RepLists[stLNK], Fnd, Rep, lblRepItem, Report);
      lblRepType.Caption := 'in the Registry';
      ReplaceREG(RepLists[stREG], Fnd, Rep, lblRepItem, Report);
    finally
      FOR N := stINI TO stREG DO
        RepLists[N].Free;
    end;
    BtnCancel.Enabled := True;
  finally
    Screen.Cursor := crDefault;
  end;
  NotebookMain.PageIndex := nbPgFinalFinal;
end;

procedure TForm1.Toggle1Click(Sender: TObject);
VAR N, Changed : Integer;
begin
  Changed := 0;
  WITH lvFound DO
    CASE (Sender AS TMenuItem).Tag OF
      1 : FOR N := 0 TO Items.Count-1 DO
            IF Items[N].Selected THEN
              begin
                Items[N].ImageIndex := Items[N].ImageIndex XOR 1;
                Inc(Changed);
                IF Changed = SelCount THEN Break;
              end;
      2 : FOR N := 0 TO Items.Count-1 DO
            IF Items[N].Selected THEN
              begin
                Items[N].ImageIndex := 0;
                Inc(Changed);
                IF Changed = SelCount THEN Break;
              end;
      3 : FOR N := 0 TO Items.Count-1 DO
            IF Items[N].Selected THEN
              begin
                Items[N].ImageIndex := 1;
                Inc(Changed);
                IF Changed = SelCount THEN Break;
              end;
    END;
end;

procedure TForm1.lvFoundKeyPress(Sender: TObject; var Key: Char);
begin
  IF Key = #32 THEN Toggle1Click(Toggle1);
end;

procedure TForm1.NotebookSubPageChanged(Sender: TObject);
begin
  WITH NotebookSub DO
    HelpContext := TPage(Pages.Objects[PageIndex]).HelpContext;
  NotebookMain.HelpContext := NotebookSub.HelpContext;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  KeyWasF1 := (Key = VK_F1) AND (Shift=[]);
end;

procedure TForm1.EditToStringAgainChange(Sender: TObject);
begin
  IF NoteBookMain.PageIndex = nbPgFinalPage THEN
    btnNext.Enabled := EditNewAddressAgain.Text <> '';
end;

procedure TForm1.FormResize(Sender: TObject);
VAR N : Integer;
begin
  // Form starts at 540x312 and never gets *smaller*
  BtnPrev.Left := Width - (540-286);
  BtnNext.Left := Width - (540-359);
  BtnCancel.Left := Width - (540-456);
  EditOldAddress.Width := Width - (540-386);
  BtnBrowseDirFrom.Left := Width - (540-476);
  BtnBrowseFileFrom.Left := Width - (540-501);
  EditNewAddress.Width := Width - (540-386);
  BtnBrowseDirTo.Left := Width - (540-476);
  BtnBrowseFileTo.Left := Width - (540-501);
  cbShowAll.Top := Height - (312- 224);
  FOR N := nbPgIniFiles TO nbPgIgnoreKeys DO
    SkipCBs[N].Top := Height - (312-224);
  lbIgnoreKey.Width := Width - (540- 436);
  NotebookSub.Width := Width - (540-440);
  btnSaveList.Left := NotebookSub.Width - (440-336);
  lvFound.Width := Width - (540-528);
  lvFound.Height := Height - (312-160);
  pnlShowFromString.Width := Width - (540- 417);
  EditNewAddressAgain.Width := Width - (540- 417);
  btnSaveLog.Left := Width - (540-427);
  lbReport.Width := Width - (540 - 437);
  lbReport.Height := Height - (312 - 160);
end;

procedure TForm1.btnSaveLogClick(Sender: TObject);
begin
  WITH SaveDialog2 DO
    begin
      Filename := ExtractFileDir(Application.ExeName) +
        '\COA32LOG.TXT';
      IF Execute THEN
        lbReport.Items.SaveToFile(Filename);
    end;
end;

procedure TForm1.btnInputBadClick(Sender: TObject);
begin
  WITH Sender AS TBitBtn DO
    MessageDlg(LoadStr(InputRating+10), TMsgDlgType(Tag),
      [mbOK, mbHelp], Possible_Input_Problems);
end;

end.

