unit Thd_Grp;
// Only used in Windows NT 3.51

interface
uses
  Windows, SysUtils, Classes, Controls, StdCtrls, CoaGenl, CoaThds,
  DdeMan, Forms;

type
  TSearchGrpThread = class(TCOAThread)
  protected
    fDDECli    : TDDEClientConv;
    fRequest   : String;
    fReqBuffer : PChar;
    procedure SyncDdeRequest;
  public
    constructor Create(vType : Integer; const vFind : String;
      vPathLbl : TLabel; vAddItem : AddType; vDDECli :
      TDDEClientConv);
    procedure Execute; override;
  END;

procedure ReplaceGRP(ToDo : TStringList; const Fnd, Rep : String;
  lblItem : TLabel; Report: ReportType; DdeCli : TDdeClientConv;
  DdeList : TStringList);

implementation

constructor TSearchGrpThread.Create(vType : Integer; const vFind :
  String; vPathLbl : TLabel; vAddItem : AddType; vDDECli :
  TDDEClientConv);
begin
  Inherited Create(vType, vFind, vPathLbl, vAddItem);
  fDDECli := vDdeCli;
end;

procedure TSearchGrpThread.SyncDdeRequest;
begin
  fReqBuffer := fDdeCli.RequestData(fRequest);
end;

// figure 5 begin
procedure TSearchGrpThread.Execute;
VAR
  ItemList,
  GrpList : TStringList;
  ToDoIdx, ItemIdx : Integer;
  sCmd, sWrk, sIco : String;

  procedure BreakDown(const S : String);
  VAR
    pStart, pEnd : Integer;
  begin
    pStart := 2;
    pEnd := Pos('",', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    fcurItem := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+3;
    pEnd := Pos('",', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    sCmd := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+2;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    sWrk := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    sIco := Copy(S, pStart, pEnd-pStart);
   end;
begin
  ItemList := TStringList.Create;
  GrpList := TStringList.Create;
  try
    fRequest := 'Groups';
    Synchronize(SyncDdeRequest);
    GrpList.SetText(fReqBuffer);
    StrDispose(fReqBuffer);
    FOR ToDoIdx := 0 TO GrpList.Count-1 DO
      begin
        IF Terminated THEN Break;
        fCurPath := GrpList[ToDoIdx];
        Synchronize(SyncUpdatePath);
        fRequest := GrpList[ToDoIdx];
        Synchronize(SyncDdeRequest);
        ItemList.SetText(fReqBuffer);
        StrDispose(fReqBuffer);
        IF ItemList.Count > 1 THEN
          begin
            ItemList.Delete(0);
            FOR ItemIdx := 0 TO ItemList.Count-1 DO
              begin
                BreakDown(ItemList[ItemIdx]);
                IF DoFind(sCmd) THEN
                  begin
                    fSubType := sitCommand;
                    fContext := sCmd;
                    Synchronize(SyncAddItem);
                  end;
                IF DoFind(sWrk) THEN
                  begin
                    fSubType := sitWorkDir;
                    fContext := sWrk;
                    Synchronize(SyncAddItem);
                  end;
                IF DoFind(sIco) THEN
                  begin
                    fSubType := sitIconLoc;
                    fContext := sIco;
                    Synchronize(SyncAddItem);
                  end;
              end;
          end;
      end;
  finally
    GrpList.Free;
    ItemList.Free;
  end;
end;
// figure 5 end

procedure ReplaceGRP(ToDo : TStringList; const Fnd, Rep : String;
  lblItem : TLabel; Report: ReportType; DdeCli : TDdeClientConv;
  DdeList : TStringList);
VAR
  ToDoIdx, N,
  ChngIdx,
  ItemIDX      : Integer;
  vSit         : Integer;
  ItemList,
  ChgList      : TStringList;
  nmGRP        : String;
  P            : PChar;
  AnyChange    : Boolean;
  // these next vars are extracted from ProgMan's reported item info
  // and re-assembled in a different order for AddItem macro
  fItNam, fItWrk, fItCmd, fItIco : String;
  fItXPos, fItYPos,
  fItIconIndex, fItShortcut,
  fItMinFlag, fItSepmem : Integer;
  AddString : String;

  procedure SplitUp(const S : String);
  VAR
    pStart, pEnd : Integer;
    TmpS         : String;
  begin
    pStart := 2;
    pEnd := Pos('",', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    fItNam := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+3;
    pEnd := Pos('",', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    fItCmd := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+2;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    fItWrk := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    fItIco := Copy(S, pStart, pEnd-pStart);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItXPos := StrToIntDef(TmpS, 0);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItYPos := StrToIntDef(TmpS, 0);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItIconIndex := StrToIntDef(TmpS, 0);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItShortcut := StrToIntDef(TmpS, 0);
    pStart := pEnd+1;
    pEnd := Pos(',', Copy(S, pStart, Length(S)-pStart+1))+pStart-1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItMinFlag := StrToIntDef(TmpS, 0);
    pStart := pEnd+1;
    pEnd := Length(S)+1;
    tmpS := Copy(S, pStart, pEnd-pStart);
    fItSepMem := StrToIntDef(TmpS, 0);
   end;

begin
  ItemList := TStringList.Create;
  FOR ToDoIdx := 0 TO ToDo.Count-1 DO
    begin
      nmGRP := ToDo[ToDoIdx];
      Report('');
      Report('Updating ProgMan Group ' + ToDo[ToDoIdx]);
      ChgList := (ToDo.Objects[ToDoIdx] AS TStringList);
      lblItem.Caption := nmGRP;
      Application.ProcessMessages;
      DdeList.Add('[CreateGroup('+nmGRP+')]');
      FOR N := 1 TO 3 DO // try three times, just in case
        WITH ddeCli DO
          begin
            SetLink('ProgMan','ProgMan');
            OpenLink;
            P := RequestData(nmGRP);
            CloseLink;
            ItemList.SetText(P);
            StrDispose(P);
            IF ItemList.Count > 0 THEN Break;
          end;
      IF ItemList.Count > 1 THEN
        FOR ItemIdx := 1 TO ItemList.Count-1 DO
          begin
            SplitUp(ItemList[ItemIdx]);
            AnyChange := False;
            FOR ChngIdx := ChgList.Count-1 DOWNTO 0 DO
              IF ChgList[ChngIdx] = fItNam THEN
                begin
                  AnyChange := True;
                  TObject(vSit) := ChgList.Objects[ChngIdx];
                  CASE vSIT OF
                    sitCommand : StrChange(fItCmd, Fnd, Rep);
                    sitIconLoc : StrChange(fItIco, Fnd, Rep);
                    sitWorkDir : StrChange(fItWrk, Fnd, Rep);
                  END;
                  ChgList.Delete(ChngIdx);
                end;
             IF AnyChange THEN
               begin
                 DdeList.Add('[ReplaceItem('+fItNam+')]');
                 AddString := Format('%s,%s,%s,%d,%d,%d,%s,%d,%d,%d',
                   [fItCmd, fItNam, fItIco, fItIconIndex, fItXpos,
                   fItYpos,fItWrk,fItShortcut,fItMinFlag,fItSepMem]);
                 Report('             item: ' + ItemList[ItemIdx]);
                 Report('       changed to: ' + AddString);
                 DdeList.Add('[AddItem('+AddString+')]');
               end;
             IF ChgList.Count = 0 THEN Break;
          end;
      IF ChgList.Count = 0 THEN
        Report('Successfully updated ' + nmGRP)
      ELSE
        begin
          Report('***** Updated ' + nmGRP +', but some items not found:');
          FOR ChngIdx := 0 TO ChgList.Count-1 DO
            begin
              TObject(vSit) := ChgList.Objects[ChngIdx];
              Report(Format('    %s for %s', [SITNames[vSit],
                ChgList[ChngIdx]]));
            end;    
        end;
      ChgList.Free;
    end;
  ItemList.Free;
end;

end.
