             RAVENLOFT: STONE PROPHET - Part 1

                Solution by Diana Griffiths

INTRODUCTION

This walkthrough assumes you have read the Stone Prophet manual
and are familiar with operating the game's user interface.  You
should also have a reasonable knowledge of how best to equip your
party of characters and how and when to use spells.  This is not a
detailed step by step set of instructions. The walkthrough does
provide general hints and instruct you in what items to seek, and
in which general locations. This will help you progress
efficiently without spoiling the general experience of exploration
and the adventure of finding the unexpected. There will be many
buttons to push, pressure plates to step on and locks to open. I
have rarely mentioned these explicitly. And the walkthrough
virtually ignores the ever present monsters in every location that
you will have to clear out before safely exploring most locations.

Everywhere you go you will find useful scrolls, weapons, health
improving items, clothes, armor, etc. Collecting and using such
items will be essential to progressing, but I only mention picking
up especially significant items which will be absolutely necessary
to complete the game successfully. Stone Prophet is not a linear
game, so this walkthrough is only one order of events while many
others will also lead to a successful game completion

GENERAL HINTS

1. This walkthrough assumes you either use the quick start party
or create your own two characters: a magic user/fighter and a
cleric/ranger.
2.  If you run low on water, clerics should cast the create
water spell. It is a good idea to pray for the create water
spell. Alternatively, there is a well to the north of
Muhar.
3. The little round green containers hold a yellow salve which
when ingested cures poisoned or diseased characters. It is called
Keoghtams Ointment.
4. The periapts will slow harmful effects on your party members if
you keep them in your inventory slots rather than in a sack or
chest.
5. There are several NPCs (non-player characters) available who
can join you on your adventure. NPCs can be dismissed from the
party and can be collected later from where you originally found
them, provided they are not dismissed when dead. You will only be
able to dismiss an NPC when you invite a fifth character to join
your party. Your maximum party size is four.  The Undead Paladin
is a special case. She will leave of her own accord when you
complete her particular quest. So I have left it to the end of the
game to complete her quest. You can complete her quest at any time
earlier once you have the skill, knowledge and equipment to do so.
The available NPCs are listed here in my order of preference
together with the location they can be found. * Undead Paladin -
north-west of Burial Catacombs: Ground Floor * Jackalwere Cleric -
north-center of Sphinx: Hall of Insight (V1.1 only) * Wemic
Fighter - north-east of Obelisk in the desert * Troll Fighter - on
the way to the far north of the desert * Ranger/Cleric - east of

Neferti and north west of Set in the desert * Piotra the Thief -
south-east of Muhar
6. I found the cleric spell, Flame Blade, was incredibly useful
and I used it almost constantly against all monsters. This works
if you keep your cleric at the front of the party. I also found
Summon Insects very useful, but they can hurt your party too.
7. Pyre elementals can be easily killed using Lightning spells or,
if you are protected against fire, just hack at them with
conventional weapons.
8. Use the Improved Detection spell to identify your best weapons.
9. Magic users will not be able to cast spells if they wear non
elven armor. There are some powerful cloaks of protection and
elven chain mail to be found.
10. Use the teleport tiles to travel quickly from place to place.
They can usually be found at the entrance or just inside each
location. Use the teleport spell (once you have found it) to
travel quickly within a region or between regions. I found the
teleport spell particularly useful in getting around awkward
places.

11. Wear the Helmet of True Seeing as much as possible once you
have found it. This will enable you to detect illusionary walls
and other illusions.
12. Combine the pieces of the Seals in your inventory by clicking
one piece on another. You need four pieces to complete each seal.

OPENING SEQUENCE

Sent to investigate a problem in the hither-to unknown land of
Har'Akur, your party of adventurers encounters a dying woman.  She
speaks of her brother Poitra and the importance of her dagger to
her family. As she dies, you become aware of a wall of fiery heat
trapping you inside the desert of Har'Akar.

DESERT Pick up the dead woman's Vistani dagger. Head north- east
to the lone tent, go inside and speak with the woman (Min Deir).
She draws a diagram indicating you should travel east to a well.
Do so and enter the well.


FORGOTTEN SHRINE OF NEFERTI Talk to the injured woman (Sennef)
near the entrance. Sennef wants you to take her to her village of
Muhar. Accept her request and she will join your party.  Leave the
Forgotten Shrine of Neferti and go north to Muhar.

MUHAR Enter the village. Visit the old beggar, the hostile village
leader, the hostile family, the friendly boy and Piotra. Give
Piotra the Vistani dagger and have him join your party. If you
find the attributes of a thief character useful, you may keep him
for a while. However, he is a limited character compared with the
other NPCs. Also visit the woman whose husband has left her and
taken all their supplies. You will find supplies, spells and clues
in the other tents.

DESERT Now you need to get build up some experience and/or get
some help before you can easily cope with exploring further the
Forgotten Shrine of Neferti. Wander extensively around the desert,
killing desert zombies and giant vultures with regular weapons and
dust devils with flame and fire spells. It is probably better to
avoid any other monsters at this stage, so run away if anything
else approaches you. You should also meet some non- player
characters (NPCs). Invite the Troll and/or the Wemic to join you.
Find the dying man, north of Muhar, and take the sack of supplies
back to his wife in Muhar. Now you should return south to the
Forgotten Shrine of Neferti.

FORGOTTEN SHRINE OF NEFERTI Pick up the key in the north- east
area. Get the eye in the south-east area. You may need to click a
button to close the pit so you can get to the eye. Get the key in
the south-west area. Collect the Seal piece in the south- west
corner. Get the second eye in the north-west area. Fall through a
pit further north and collect the Helm of Telepathy.  Return up
the stairs to the north and push the button to close the pit. Pick
up the Helm of Brilliance. Wear this helm instead of casting light
spells. Return to Min Deir. Wear the Helm of Telepathy and make
sure the eyes are in the inventory slots, not inside a container.
Talk to Min Deir. She will join your party. (Drop Piotra if you
need to, otherwise drop the Wemic or Troll.) Go to the Obelisk in
the central part of the desert.

OBELISK The main objective here is to find all eight scraps of
paper (four blue edged and four red edged) so that you can read
the inscription on the first level. This is a translation of the
inscription: "Hot gales the sands arise. Flesh corrupts and falls
away. These are the signs of their coming. The wrath of Ankhepot
burns the land. Who hopes to rule must lure the evil to him. In
the Ancient Burial Hall the Guardian of the Gate of the Dead
awaits.  She shall judge them by deeds both good and bad. Her son
the sweet lute did play. This gentle music the ghost awaits. To
the priest, the mystic urn is given. The Temple of Harvest shall
be restored. Beyond the Gate of the Dead, he awaits. The soul of
the stranger knows the way. Master of the Winged Wind. Three
signals the whistle sounds, summoning forth the falcon. The eight
tears shall fall. Ra weeps and the stone shatters, a fragment of
the seal revealed. They capture the sun and in a coffer hold the
might of Ra. By its light, the soul and the seal are freed. Two
seals, each in four pieces lie. Piece to piece, the seals rejoined
two gates are opened. Into conflict, the foes are led: Ankhepot
and the other. When falls the wall of Ra, two gates be opened.
The way home." You must also find a Seal piece on lower level 3.
Just east of the center of this level is a rectangular room, with
three entrances from the north, running east to west. The Seal
piece is in this room. Leave the Obelisk and go to the Temple of
Set to the south-east.

TEMPLE OF SET Go upstairs. Get six snake idols from upper level 1.
Go upstairs. Get the Helm of True Seeing from upper level 2. Have
one of your party wear it. Get another three snake idols from
upper level 2. Go down to the temple grounds. Use the snake idols
to open the locked rooms. Get the Magic Watering Urn and the Seal
piece. Leave the Temple of Set and go north- west to the Ruined
Temple of Harvest.

RUINED TEMPLE OF HARVEST Get the Mask of Hathor and have a member
of your party wear it. Go to the kitten and speak with him. Take
the key, then use it to enter the nearby area. Take the feline
figurine. Use the key to open the doors that run through the
center of the temple northwards to the old man. Talk with him then
hand over the Magic Watering Urn. The old man should have with him
the small child who ran away when you visited the hostile family
in Muhar. Have the child accompany you (drop the Troll or Wemic
and pick him up again later, if necessary) and return to Muhar.

MUHAR Visit the hostile family's tent to return the child to her
parents. Talk to the father. Visit the hostile leader's tent.
Return to the Ruined Temple of Harvest.

RUINED TEMPLE OF HARVEST Return to the area where you met the old
man and child. Pick up all the air spores you can.  Press the
button on the other side of the wall behind the old man (to the
south) and find the steps to the level below. Offer the feline
statue to the statue with the gray markings. Go through the door
that opened and get the Secret of the Sphinx scroll, the lioness
and jackal figurines. Continue as follows: Give the jackal to the
statue with red markings and get the falcon from the new area.
Give the lioness to the statue with beige markings and get the
Coffer of Ra and large chain from the new area. Give the falcon to
the statue with pink markings and get the scroll of retirement
from the new area. Go to the south-east area, step on two pressure
plates to open the far south-east corner and collect the vulture
figurine. Offer the vulture figurine to the statue with turquoise
markings. Have each party member ingest an air spore then enter
the green area. Find the golden statue. Talk to him then use the
Coffer of Ra. Pick up the Seal piece. Collect the scorpion
figurine.  Offer the scorpion to the statue with green markings.
Ingest more air spores, if necessary, and before entering this
green area.

@~To be continued next issue










                              - o -
